Note: this is the third version of this patch.

Apply by doing
	cd /usr/src/sys/netinet
	patch -p0 < tcpfix.patch

And then rebuild your kernel.

--- ip_input.c.orig	Fri Nov 13 15:26:49 1998
+++ ip_input.c	Fri Nov 13 15:27:04 1998
@@ -1,4 +1,4 @@
-/*	$OpenBSD: ip_input.c,v 1.30 1998/02/14 18:50:36 mickey Exp $	*/
+/*	$OpenBSD: ip_input.c,v 1.32 1998/11/13 22:24:17 provos Exp $	*/
 /*	$NetBSD: ip_input.c,v 1.30 1996/03/16 23:53:58 christos Exp $	*/
 
 /*
@@ -388,7 +388,7 @@
 	 */
 	if (ip->ip_off &~ (IP_DF | IP_RF)) {
 		if (m->m_flags & M_EXT) {		/* XXX */
-			if ((m = m_pullup(m, sizeof (struct ip))) == 0) {
+			if ((m = m_pullup(m, hlen)) == 0) {
 				ipstat.ips_toosmall++;
 				goto next;
 			}
@@ -446,6 +446,7 @@
 				goto next;
 			ipstat.ips_reassembled++;
 			m = dtom(ip);
+			hlen = ip->ip_hl << 2;
 		} else
 			if (fp)
 				ip_freef(fp);
